/**
 * Copyright (C) 2007  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.execution.runtime;

import java.util.ArrayList;
import java.util.List;

import org.jbpm.env.Environment;
import org.jbpm.env.session.Timer;
import org.jbpm.env.session.TimerSession;

/**
 * @author Guillaume Porcher
 */

public class PickRuntime {

  /** children number of this sequence. */
  private List<Timer> onAlarmTimers;

  /**
   * default constructor.
   * 
   * @param childrenNb
   *            child number of this sequence.
   */
  public PickRuntime() {
  }

  public void addOnAlarmTimer(Timer timer) {
    if (onAlarmTimers == null) {
      onAlarmTimers = new ArrayList<Timer>();
    }
    onAlarmTimers.add(timer);
  }
  
  public void cancelOnAlarmTimers() {
    if (onAlarmTimers != null) {
      TimerSession timerSession = Environment.getCurrent().get(TimerSession.class);
      for (Timer timer : onAlarmTimers) {
        timerSession.cancel(timer);
      }
    }
  }
}
