package org.ow2.orchestra.test.integration.correlation.sales;

import java.util.HashMap;

import javax.xml.namespace.QName;

import org.ow2.orchestra.exception.OrchestraException;
import org.ow2.orchestra.execution.runtime.VariableRuntime;
import org.ow2.orchestra.test.BpelTestCase;
import org.ow2.orchestra.util.BpelUtil;
import org.ow2.orchestra.var.Message;
import org.w3c.dom.Element;

/**
 * @author Nicolas Salatge
 */
public class Stock extends BpelTestCase {

  private String ns;


  public Stock(String ns) {
    super("http://petals.ow2.org/sales", "salesAsync");
    this.ns = ns;
  }

  public Message initiate(VariableRuntime variableRuntime) {
    Object varValue = variableRuntime.getValue();
    if (!(varValue instanceof Message)) {
      throw new OrchestraException("variableRuntime value is not a message");
    }

    Message getStockRequest = (Message) varValue;
    Element stockRequest = getStockRequest.getPartValue("payload");

    String refId = stockRequest.getFirstChild().getFirstChild().getTextContent();

    int ref = Integer.parseInt(refId);
    boolean res;
    if (ref % 2 == 0) {
      res = true;
    } else {
      res = false;
    }


    Element callBackResponseElement = BpelUtil.getDocumentWithOneElement(new QName(ns, "stockResponse"));

    Element refIdElmt = callBackResponseElement.getOwnerDocument().createElementNS(getProcessNamespace(), "refId");
    refIdElmt.setTextContent(refId);

    Element resultElmt = callBackResponseElement.getOwnerDocument().createElementNS(getProcessNamespace(), "result");
    resultElmt.setTextContent(String.valueOf(res));


    callBackResponseElement.appendChild(resultElmt);
    callBackResponseElement.appendChild(refIdElmt);


    HashMap<String, Element> parts = new HashMap<String, Element>();
    parts.put("payload", callBackResponseElement);


    QName portTypeQName = new QName(getProcessNamespace(), "sales");
    String operationName = "onResultStock";
    call(parts, portTypeQName, operationName);


    return new Message(parts);
  }


}
