package org.ow2.orchestra.test.integration.sc;

import java.util.HashMap;

import javax.xml.namespace.QName;

import org.ow2.orchestra.exception.OrchestraException;
import org.ow2.orchestra.execution.runtime.VariableRuntime;
import org.ow2.orchestra.util.BpelUtil;
import org.ow2.orchestra.var.Message;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class ABWS {

  private String ns;

  public ABWS(String ns) {
    this.ns = ns;
  }

  public Message getListeAdresses(VariableRuntime variableRuntime) {
    Object varValue = variableRuntime.getValue();
    if (!(varValue instanceof Message)) {
      throw new OrchestraException("variableRuntime value is not a message");
    }




    Element adressesResponseElement = BpelUtil.getDocumentWithOneElement(new QName(ns, "addresses"));
    Document doc = adressesResponseElement.getOwnerDocument();

    Element returnElement1 = getReturnElement(doc, "13", "route de Chene", "1207", "Geneve", "Geneve", "Suisse", "address");
    adressesResponseElement.appendChild(returnElement1);

    Element returnElement2 = getReturnElement(doc, "15", "route du puit", "1207", "Geneve", "Geneve", "Suisse", "address");
    adressesResponseElement.appendChild(returnElement2);


    HashMap<String, Element> parts = new HashMap<String, Element>();
    parts.put("addresses", adressesResponseElement);
    return new Message(parts);
  }

  public Element getReturnElement(Document doc, String street, String streetNumber, String zipCode,
      String town, String township, String country, String nameElmt) {
    Element returnElement = doc.createElementNS(ns, nameElmt);

    Element streetElement = doc.createElementNS(ns, "street");
    streetElement.setTextContent(street);
    returnElement.appendChild(streetElement);

    Element streetNumberElement = doc.createElementNS(ns, "streetNumber");
    streetNumberElement.setTextContent(streetNumber);
    returnElement.appendChild(streetNumberElement);

    Element zipCodeElement = doc.createElementNS(ns, "zipCode");
    zipCodeElement.setTextContent(zipCode);
    returnElement.appendChild(zipCodeElement);

    Element townElement = doc.createElementNS(ns, "town");
    townElement.setTextContent(town);
    returnElement.appendChild(townElement);

    Element townshipElement = doc.createElementNS(ns, "township");
    townshipElement.setTextContent(township);
    returnElement.appendChild(townshipElement);

    Element countryElement = doc.createElementNS(ns, "country");
    countryElement.setTextContent(country);
    returnElement.appendChild(countryElement);

    return returnElement;
  }

}
