package org.ow2.orchestra.test.integration.sc;

import java.util.HashMap;

import javax.xml.namespace.QName;

import org.ow2.orchestra.exception.OrchestraException;
import org.ow2.orchestra.execution.runtime.VariableRuntime;
import org.ow2.orchestra.util.BpelUtil;
import org.ow2.orchestra.var.Message;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class AnalyzerWS {

  private String ns;

  public AnalyzerWS(String ns) {
    this.ns = ns;
  }

  public Message getListeAdresses(VariableRuntime variableRuntime) {
    Object varValue = variableRuntime.getValue();

    if (!(varValue instanceof Message)) {
      throw new OrchestraException("variableRuntime value is not a message");
    }

    Message getListeAdressesRequest = (Message) varValue;
    Element arraySA = getListeAdressesRequest.getPartValue("getListAdressesResponseA");
    Element arraySB = getListeAdressesRequest.getPartValue("getListAdressesResponseB");

    Element arrayResponseElement = BpelUtil.getDocumentWithOneElement(new QName(ns, "getListAdressesResponse"));



    for(int i= 0; i < arraySA.getChildNodes().getLength(); i++) {
        Node n = arrayResponseElement.getOwnerDocument().adoptNode(arraySA.getChildNodes().item(i).cloneNode(true));
        arrayResponseElement.appendChild(n);
    }

    for(int i= 0; i < arraySB.getChildNodes().getLength(); i++) {
        Node n = arrayResponseElement.getOwnerDocument().adoptNode(arraySB.getChildNodes().item(i).cloneNode(true));
        arrayResponseElement.appendChild(n);
    }


    HashMap<String, Element> parts = new HashMap<String, Element>();
    parts.put("getListAdressesResponse", arrayResponseElement);
    return new Message(parts);
  }

}
