<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:pet="http://petals.ow2.org/SA"
xmlns:sc="http://petals.ow2.org/SC"
exclude-result-prefixes="pet"
version="1.0" id="address">

<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" xml-declaration="yes" />

<xsl:template match="/">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="//*[local-name() = 'addresses']">
	<xsl:element name="sc:adresses">
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<xsl:template match="//*[local-name() = 'address']">
	<xsl:element name="sc:address">
		<xsl:call-template name="addressElements" />
   	</xsl:element>
</xsl:template>

<xsl:template name="addressElements">
	<xsl:if test="street">
		<rue><xsl:value-of select="street" /></rue>
   	</xsl:if>
    <xsl:if test="streetNumber">
		<numero_rue><xsl:value-of select="streetNumber" /></numero_rue>
   	</xsl:if>
   	<xsl:if test="zipCode">
		<code_postal><xsl:value-of select="zipCode" /></code_postal>
   	</xsl:if>
   	<xsl:if test="town">
		<commune><xsl:value-of select="town" /></commune>
   	</xsl:if>
   	<xsl:if test="township">
		<canton><xsl:value-of select="township" /></canton>
   	</xsl:if>
   	<xsl:if test="country">
		<pays><xsl:value-of select="country" /></pays>
   	</xsl:if>
</xsl:template>

</xsl:stylesheet>